/*
 * myFunctions.c
 *
 *  Created on: 13.08.2013
 *      Author: DL9MWE
 */
#include "main.h"

// *********************  Umwandlung von int bzw. long in ASCII-Zeichen  *********************
//
//  fhrende Nullen knnen unterdrckt werden: trim = 1, sonst trim = 0.
//  "Nachkommastellen" (hier als'.' gedruckt) knnen angegeben werden.
//  Es wird kein! String erzeugt. D.h. ein abschlieendes '\x00' wird nicht gesetzt.

// ***************  Prototypen; diese Funktionen werden nur intern verwendet  ***************
unsigned char l2chars(long value, char* asciiChars, unsigned char stellen,
		unsigned char komma, unsigned char trim);
char cldigit(long* uiX, unsigned char stelle, unsigned char* print);

// wandelt ein int in ASCII-Zeichen um.
//  der Pointer *asciiChars muss auf ein ausreichend groes Array (min. 7) zeigen!
//	Eine Null als Stringende wird nicht! gesetzt und ist dabei nicht mitgezhlt!
//  Komma gibt die Anzahl "Nachkommastellen" an, trim = 1: fhrende Nullen unterdrcken
//  Rckgabe: Anzahl gltiger Zeichen
unsigned char itoChars(int value, char* asciiChars, unsigned char komma,
		unsigned char trim) {
	return l2chars((long) value, asciiChars, 4, komma, trim);
}

// wandelt ein long int in ASCII-Zeichen um.
//  der Stringpointer *asciiChars muss auf ein ausreichend groes Array (min. 12) zeigen!
//	Eine Null als Stringende wird nicht! gesetzt und ist dabei nicht mitgezhlt!
//  Komma gibt die Anzahl "Nachkommastellen" an, trim = 1: fhrende Nullen unterdrcken
//  Rckgabe: Anzahl gltiger Zeichen
unsigned char ltoChars(long value, char* asciiChars, unsigned char komma,
		unsigned char trim) {
	return l2chars(value, asciiChars, 9, komma, trim);
}

//                         *** Hilfsfunktionen ***
//
char cldigit(long* uiX, unsigned char stelle, unsigned char* print) {
	unsigned long y, wert = 1;
	char data;
	while (stelle) {
		wert = wert * 10;
		--stelle;
	}
	y = *uiX / wert;
	if (y || *print) {
		data = y + 0x30;
		*uiX -= y * wert;
		*print = 1;
	} else
		data = ' ';
	return data;
}

unsigned char l2chars(long value, char* asciiChars, unsigned char stellen,
		unsigned char komma, unsigned char trim) {
	unsigned char print = 0;
	unsigned int index = 1;

	if (value < 0) { // Vorzeichen bearbeiten
		value = -value;
		asciiChars[0] = '-';
	} else {
		if (!trim) {
			asciiChars[0] = ' ';
		} else
			index = 0;
	}

	while (stellen) { // fr alle Stellen bis auf die Einerstelle
		asciiChars[index] = cldigit(&value, stellen, &print);
		if (komma && komma == stellen) {
			if (asciiChars[index] == ' ')
				asciiChars[index] = '0';
			asciiChars[++index] = '.';
			print = 1;
		}
		if (!print) {
			if (trim) {
				--index;
			} else {
				if (index > 0) {
					asciiChars[index] = asciiChars[index - 1]; // evtl. Vorzeichen mitziehen
					asciiChars[index - 1] = ' ';
				}
			}
		}
		++index;
		--stellen;

	}
	asciiChars[index] = value + 0x30; // Einerstelle immer schreiben
	return index + 1;
}

void vLCD_putli(long value) {
	char cbuffer[15];

	cbuffer[ltoChars(value, cbuffer, 3, 0)] = '\x00';
	vLCD_puts(cbuffer);
}

// Ende

